﻿;/////////////////////////////////////////////////////////////////////////////////
;minScript.
;==========
;
;/////////////////////////////////////////////////////////////////////////////////

;/////////////////////////////////////////////////////////////////////////////////
;NOTES.
;
;   i)    All object code address references are relative from the start of the underlying object code file.
;/////////////////////////////////////////////////////////////////////////////////


;/////////////////////////////////////////////////////////////////////////////////
;-PROTOTYPES

  Prototype.i proto_minScript_GCExtension(codeObject.minScriptCode, uMsg)
  Prototype.i proto_minScript_poKeyword(codeObject.minScriptCode, *param.minScriptVariant)
  Prototype.i proto_minScript_runtimeFunction(codeObject.minScriptCode, fnID.l, numParamsPassed, *params.minScriptVariantParameters, *ret.minScriptVariant)
  Prototype.i proto_minScript_debuggerFunction(codeObject.minScriptCode, uMsg, param1, param2) 
;/////////////////////////////////////////////////////////////////////////////////


;/////////////////////////////////////////////////////////////////////////////////
;-CONSTANTS/STRUCTURES.
  #minScript_VARIANTSTACKSIZE                 = 4096    ;Variants.
  #minScript_INITIALMEMORYFILESIZE            = 8192
  #minScript_MEMORYFILEPAGESIZE               = 1024
  #minScript_INTERNALRUNTIMESTACKSIZE         = 2048    ;Integers.
  #minScript_MAXNUMFUNCTIONPARAMETERS         = 10
  #minScript_STRINGTABLESIZE                  = 128
  #minScript_SIZEOFOBJECTCODEINSTRUCTION      = 10
  
  #minScript_SNIPPETMODULE$                   = "^snippets"
  
  #minScript_DEFAULTPROPERTY$                 = "_^indexedvalue"
  
  ;Additional, non-native, minScriptVariant VT's. Only used for our user-defined arrays.
    Enumeration #minScript_STRING + 1
      #minScript_BYTE
      #minScript_WORD
      #minScript_CHARACTER
      #minScript_LONG
      #minScript_FLOAT
      #minScript_ENDOFVARIABLETYPES
    EndEnumeration
    
  ;minScript standard runtime. Host apps should use ID's below this value when registering runtime functions.
    #minScript_STANDARDRUNTIME_BASEID  = $10000000
  
    Enumeration #minScript_STANDARDRUNTIME_BASEID + 1
      #minScript_STANDARDRUNTIME_ALLOCATEMEMORY
      #minScript_STANDARDRUNTIME_ASC
      #minScript_STANDARDRUNTIME_CHR
      #minScript_STANDARDRUNTIME_CLOSEFILE
      #minScript_STANDARDRUNTIME_CREATEFILE
      #minScript_STANDARDRUNTIME_EOF
      #minScript_STANDARDRUNTIME_FILESIZE
      #minScript_STANDARDRUNTIME_FINDSTRING
      #minScript_STANDARDRUNTIME_FREEMEMORY
      #minScript_STANDARDRUNTIME_GETEXTENSIONPART
      #minScript_STANDARDRUNTIME_GETFILEPART
      #minScript_STANDARDRUNTIME_GETPATHPART
      #minScript_STANDARDRUNTIME_HEX
      #minScript_STANDARDRUNTIME_ISCLASS
      #minScript_STANDARDRUNTIME_ISFUNCTION
      #minScript_STANDARDRUNTIME_ISREFERENCETYPE
      #minScript_STANDARDRUNTIME_ISRUNTIMEFUNCTION
      #minScript_STANDARDRUNTIME_LCASE
      #minScript_STANDARDRUNTIME_LEFT
      #minScript_STANDARDRUNTIME_LEN
      #minScript_STANDARDRUNTIME_LOC
      #minScript_STANDARDRUNTIME_LOF
      #minScript_STANDARDRUNTIME_LSET
      #minScript_STANDARDRUNTIME_MID
      #minScript_STANDARDRUNTIME_NOTHING
      #minScript_STANDARDRUNTIME_OPENFILE
      #minScript_STANDARDRUNTIME_PEEKB
      #minScript_STANDARDRUNTIME_PEEKC
      #minScript_STANDARDRUNTIME_PEEKCURRENCY
      #minScript_STANDARDRUNTIME_PEEKF
      #minScript_STANDARDRUNTIME_PEEKL
      #minScript_STANDARDRUNTIME_PEEKI
      #minScript_STANDARDRUNTIME_PEEKR
      #minScript_STANDARDRUNTIME_PEEKS
      #minScript_STANDARDRUNTIME_PEEKW
      #minScript_STANDARDRUNTIME_POKEB
      #minScript_STANDARDRUNTIME_POKEC
      #minScript_STANDARDRUNTIME_POKECURRENCY
      #minScript_STANDARDRUNTIME_POKEF
      #minScript_STANDARDRUNTIME_POKEL
      #minScript_STANDARDRUNTIME_POKEI
      #minScript_STANDARDRUNTIME_POKER
      #minScript_STANDARDRUNTIME_POKES
      #minScript_STANDARDRUNTIME_POKEW
      #minScript_STANDARDRUNTIME_READBYTE
      #minScript_STANDARDRUNTIME_READCHARACTER
      #minScript_STANDARDRUNTIME_READDATA
      #minScript_STANDARDRUNTIME_READDOUBLE
      #minScript_STANDARDRUNTIME_READFILE
      #minScript_STANDARDRUNTIME_READFLOAT
      #minScript_STANDARDRUNTIME_READINTEGER
      #minScript_STANDARDRUNTIME_READLONG
      #minScript_STANDARDRUNTIME_READSTRING
      #minScript_STANDARDRUNTIME_READSTRINGFORMAT
      #minScript_STANDARDRUNTIME_READWORD
      #minScript_STANDARDRUNTIME_REALLOCATEMEMORY
      #minScript_STANDARDRUNTIME_RIGHT
      #minScript_STANDARDRUNTIME_RSET
      #minScript_STANDARDRUNTIME_SIZEOF
      #minScript_STANDARDRUNTIME_SPACE
      #minScript_STANDARDRUNTIME_STR
      #minScript_STANDARDRUNTIME_STRFIX
      #minScript_STANDARDRUNTIME_STRINGBYTELENGTH
      #minScript_STANDARDRUNTIME_STRINGFIELD
      #minScript_STANDARDRUNTIME_THROWERROR
      #minScript_STANDARDRUNTIME_TOCURRENCY
      #minScript_STANDARDRUNTIME_TOINTEGER
      #minScript_STANDARDRUNTIME_TOREAL
      #minScript_STANDARDRUNTIME_TOSTRING
      #minScript_STANDARDRUNTIME_TRIM
      #minScript_STANDARDRUNTIME_TRUNCATE
      #minScript_STANDARDRUNTIME_TYPEOF
      #minScript_STANDARDRUNTIME_TYPEOF2STRING
      #minScript_STANDARDRUNTIME_UCASE
      #minScript_STANDARDRUNTIME_WRITEBYTE
      #minScript_STANDARDRUNTIME_WRITECHARACTER
      #minScript_STANDARDRUNTIME_WRITEDOUBLE
      #minScript_STANDARDRUNTIME_WRITEFLOAT
      #minScript_STANDARDRUNTIME_WRITEINTEGER
      #minScript_STANDARDRUNTIME_WRITELONG
      #minScript_STANDARDRUNTIME_WRITESTRING
      #minScript_STANDARDRUNTIME_WRITESTRINGFORMAT
      #minScript_STANDARDRUNTIME_WRITESTRINGN
      #minScript_STANDARDRUNTIME_WRITEWORD
      #minScript_STANDARDRUNTIME_NEWARRAY               ;Runtime function for creating new arrays.
      #minScript_STANDARDRUNTIME_NEWCLASS               ;Runtime function for creating new classes.
      #minScript_STANDARDRUNTIME_NEWHASHMAP             ;Runtime function for creating new hashmaps.
      #minScript_STANDARDRUNTIME_NEWPOINTER             ;Runtime function for creating new pointers.
      #minScript_STANDARDRUNTIME_NEWSTRINGBUILDER       ;Runtime function for creating new string builders.
    EndEnumeration

  ;minScript compiler runtime functions.
    #minScript_COMPILERRUNTIME_BASEID  = $20000000
    
    Enumeration #minScript_COMPILERRUNTIME_BASEID + 1
    EndEnumeration
  
  ;Object code op-codes.
    Enumeration
      ;Debugging ops.
        #MS_OP_DEBUG_NOP          ;#MS_OP_DEBUG_NOP <lineNumber>
                                  ;Indicates the start of a new source line.
        #MS_OP_ADD                ;Pop 2 operands, add and push the result.
        #MS_OP_AND                ;Pop 2 operands, 'logical and', and push the result.
        #MS_OP_BITWISEAND         ;Pop 2 operands, 'bitwise and', and push the result.
        #MS_OP_BITWISENOT         ;Bitwise not the operand on the top of the stack.
        #MS_OP_BITWISEOR          ;Pop 2 operands, 'bitwise or', and push the result.
        #MS_OP_BITWISESHIFTLEFT   ;Pop 2 operands, 'bitwise shift left', and push the result.
        #MS_OP_BITWISESHIFTRIGHT  ;Pop 2 operands, 'bitwise shift right', and push the result.
        #MS_OP_BITWISEXOR         ;Pop 2 operands, 'bitwise xor', and push the result.
        #MS_OP_CALLFUNCTION       ;#MS_OP_CALLFUNCTION <1-based string table index>
        #MS_OP_CALLRTFUNCTION     ;#MS_OP_CALLRTFUNCTION <numParamsPassed<<32|fnID>
        #MS_OP_CAST               ;#MS_OP_CAST <vType>. Cast the operand on the top of the stack to the given type.
        #MS_OP_DEBUG              ;#MS_OP_DEBUG <value to output>.
        #MS_OP_DIV                ;Pop 2 operands, divide and push the result.
        #MS_OP_DUP                ;Duplicates the top of the stack.
        #MS_OP_EBPTOESP           ;Copies the EBP register to the ESP one. All invalidated stack variants will be cleared.
        #MS_OP_EQU                ;Pop 2 operands and push an integer value of 1 if op1 = op2.
        #MS_OP_ESPTOEBP           ;Copies the ESP register to the EBP one.
        #MS_OP_GT                 ;Pop 2 operands and push an integer value of 1 if op1 > op2.
        #MS_OP_GTE                ;Pop 2 operands and push an integer value of 1 if op1 >= op2.
        #MS_OP_METHOD_INVOKE      ;#MS_OP_METHOD_INVOKE <numParamsPassed<<32|1-based string table index>
        #MS_OP_METHOD_GET         ;#MS_OP_METHOD_GET <numParamsPassed<<32|1-based string table index>
        #MS_OP_METHOD_SET         ;#MS_OP_METHOD_SET <numParamsPassed<<32|1-based string table index>
        #MS_OP_METHOD_GETOBJECT   ;#MS_OP_METHOD_GETOBJECT <numParamsPassed<<32|1-based string table index>
        #MS_OP_JMP                ;#MS_OP_JMP <relativeAddress>. Unconditional jump (relative to start of function code block).
        #MS_OP_JMPNZ              ;#MS_OP_JMPNZ <relativeAddress>. Pop a single operand and jump (relative to start of function code block) if the operand is null.
        #MS_OP_JMPZ               ;#MS_OP_JMPZ <relativeAddress>. Pop a single operand and jump (relative to start of function code block) if the operand is non-null.
        #MS_OP_LOCALPARAM         ;An instruction to the VM to adjust the EBP register for a local param etc.
                                  ;#MS_OP_LOCALPARAM <vType>
        #MS_OP_LOCALVAR           ;An instruction to the VM to adjust the ESP register for a local variable etc.
                                  ;#MS_OP_LOCALVAR <vType>
        #MS_OP_LT                 ;Pop 2 operands and push an integer value of 1 if op1 < op2.
        #MS_OP_LTE                ;Pop 2 operands and push an integer value of 1 if op1 >= op2.
        #MS_OP_MUL                ;Pop 2 operands, multiply and push the result.
        #MS_OP_NEG                ;Negates the value on the top of the variant stack.
        #MS_OP_NEQ                ;Pop 2 operands and push an integer value of 1 if op1 <> op2.
        #MS_OP_OR                 ;Pop 2 operands, 'logical or', and push the result.
        #MS_OP_POKEYWORD0         ;#MS_OP_POKEYWORD0 <address>. Call a poKeyword with 0 stack-based parameters.
        #MS_OP_POKEYWORD1         ;#MS_OP_POKEYWORD1 <address>. Call a poKeyword with 1 stack-based parameter.
        #MS_OP_POP                ;#MS_OP_POP <numElementsToPop>. Pop a value from the top of the stack and discard.
        #MS_OP_POPEAX
        #MS_OP_POPEBP             ;Pop a value from the internal integer stack and place it in the EBP register.
        #MS_OP_POPLOCALVAR        ;#MS_OP_POPLOCALVAR <EBP offset>
        #MS_OP_POPSCRIPTVAR       ;#MS_OP_POPSCRIPTVAR <address of minScriptVariant>
        #MS_OP_PUSHADDRLOCALVAR   ;#MS_OP_PUSHADDDRLOCALVAR <EBP offset>
        #MS_OP_PUSHADDRSCRIPTVAR  ;#MS_OP_PUSHADDRSCRIPTVAR <address of minScriptVariant>
        #MS_OP_PUSHADDRSTR        ;***UNUSED AT PRESENT.*** #MS_OP_PUSHADDRSTR <1-based string table index>. ***UNUSED AT PRESENT.***
        #MS_OP_PUSHCUR            ;Operand is in quad form.        
        #MS_OP_PUSHEAX            ;Moves the contents of the EAX register to the variant stack and empties the register (faster than copying to the top of the stack).
        #MS_OP_PUSHEBP            ;Push the EBP register onto the internal integer stack.   
        #MS_OP_PUSHINT        
        #MS_OP_PUSHLOCALVAR       ;#MS_OP_PUSHLOCALVAR <EBP offset>
        #MS_OP_PUSHNULL           ;Pushes an empty variant.
        #MS_OP_PUSHREAL           ;Operand is in quad form.
        #MS_OP_PUSHSCRIPTVAR      ;#MS_OP_PUSHSCRIPTVAR <address of minScriptVariant>
        #MS_OP_PUSHSTR            ;#MS_OP_PUSHSTR <1-based string table index>
        #MS_OP_RET                ;Return to the calling code/host.
        #MS_OP_SUB                ;Pop 2 operands, subtract and push the result.
        #MS_OP_XOR                ;Pop 2 operands, 'logical xor', and push the result.
    EndEnumeration

  ;The following structure holds information on poKeywords.
    Structure st_minScriptpoKeyword
      friendlyName$                           ;Map key is lowercase.
      address.i
    EndStructure

  ;The following structure holds information on global constants.
    Structure st_minScriptGlobalConstant
      friendlyName$                           ;Map key is lowercase.
      value$                                  ;For string type constants.
      value.minScriptVariant                  ;For all numeric types.      
    EndStructure

  ;The following structure holds information on run-time functions.
    Structure st_minScriptRuntimeFunction
      friendlyName$                           ;Map key is lowercase.
      fnID.l                                  ;Upper 4 bits are reserved for system use.
      address.i
    EndStructure

  ;The following structure wraps up most of our global variables.
    Structure st_minScript_Globals
      Map minScriptKeywords.s()
      Map minScriptpoKeywords.st_minScriptpoKeyword()
      Map minScriptGlobalConstants.st_minScriptGlobalConstant()
      Map runtimeFunctionsTableByName.st_minScriptRuntimeFunction()
      Map *runtimeFunctionsTableByID.st_minScriptRuntimeFunction()
      Map userDefinedTypes.u()    ;The map holds user defined minScriptVariant VT types.
      List ptrGCExtensions.i()    ;A list of pointers to GC extensions. proto_minScript_GCExtension values.
      currentClassPartVT.i        ;Used to create unique classVTs across code objects (especially the GCL).
      ;The following assists with the evaluation of constant expressions as we do not employ expression folding techniques.
      ;Saves us monkeying around with code objects being used by the host app.
        constantExpressionObject.minScriptCode
        *ptrConstantExpressionObject.st_minScriptCodeClass
        *constantExpressionReturnVar.minScriptVariant ;For convenient access to constant expression results.
        blnNoDebugASM.i   ;We use this to temporarily disable the output of ASM to the debugger whilst evaluating constant expressions.
      numCodeObjects.i    ;Used to restrict access to the GCL whilst there are instantiated code objects around.
      ;The following is only used if the threadsafe compiler switch is set and is used to protect access to the GCL and other global resources (inc the constant expression object).
        threadMutex.i
    EndStructure

  ;-Memory reading.
  ;The following structure is used for convenience for reading memory.
    Structure st_minScript_memoryPointer
      StructureUnion
        a.a
        b.b
        c.c
        w.w
        l.l
        q.q
        f.f
        d.d
        i.i
        u.u
        variant.minScriptVariant
        *refPtr.minScriptObjectVariant
        sPtr.i
      EndStructureUnion
    EndStructure
;/////////////////////////////////////////////////////////////////////////////////


;/////////////////////////////////////////////////////////////////////////////////
;-GLOBALS.
  ;Global class library.
  ;Allows for shared access of classes etc.
    Global minScriptGlobalClassLib.minScriptCode
  Global minScript_Globals.st_minScript_Globals
  Global minScriptINIT.i
;/////////////////////////////////////////////////////////////////////////////////


;/////////////////////////////////////////////////////////////////////////////////
;-INCLUDES.

  IncludePath #minScript_HOME + "Includes"
    XIncludeFile "memoryFile.pbi"
    XIncludeFile "integerStack.pbi"
    XIncludeFile "threadStorage.pbi"

  EnableExplicit

  IncludePath #minScript_HOME + "Modules"
    XIncludeFile "minScriptGCExtensions.pbi"
    XIncludeFile "minScriptKeywords.pbi"
    XIncludeFile "minScriptGlobalConstants.pbi"
    XIncludeFile "minScriptVariantUtils.pbi"

  IncludePath #minScript_HOME + "Classes"
    XIncludeFile "CLASS_Code.pbi"

  IncludePath #minScript_HOME + "Modules"
    XIncludeFile "minScriptArrays.pbi"
    XIncludeFile "minScriptHashMaps.pbi"
    XIncludeFile "minScriptPointers.pbi"
    XIncludeFile "minScriptStringBuilder.pbi"
    XIncludeFile "minScriptClasses.pbi"
    XIncludeFile "minScriptRuntimeFunctions.pbi"
    XIncludeFile "minScriptUserDefinedTypes.pbi"
    XIncludeFile "minScriptCodeEditor.pbi"
;/////////////////////////////////////////////////////////////////////////////////


;/////////////////////////////////////////////////////////////////////////////////
;-INIT function.
;DO NOT CALL THIS DIRECTLY! Instead, simply check the value of minScriptINIT.
Procedure.i minScriptInit()
  Protected result = #minScript_OKAY, keyword$
  ;First we load up the minScript basic keywords.
    Define.s keyword$
    ;The following label resides within the 'minScriptKeywords.pbi' file.
      Restore minScriptKeyWords
    Read.s keyword$
    While keyword$ <> "x"
      AddMapElement(minScript_Globals\minScriptKeywords(), LCase(keyword$))
      minScript_Globals\minScriptKeywords() = keyword$
      Read.s keyword$
    Wend
  ;Attempt to init the Scintilla control.
    CompilerIf  #PB_Compiler_OS = #PB_OS_Windows 
      If InitScintilla() = 0
        ProcedureReturn 1
      EndIf
    CompilerEndIf
  ;Create a global mutex if appropriate.
    CompilerIf #PB_Compiler_Thread
      minScript_Globals\threadMutex = CreateMutex()
      If minScript_Globals\threadMutex = 0
        ProcedureReturn 1
      EndIf
    CompilerEndIf
  ;Initialise the various global code objects .
    minScript_Globals\constantExpressionObject = minScript_NewCodeObject()
  If minScript_Globals\constantExpressionObject 
    minScript_Globals\ptrConstantExpressionObject = minScript_Globals\constantExpressionObject 
    minScript_Globals\constantExpressionReturnVar = minScript_Globals\constantExpressionObject\GetReturnVariantPtr()
    ;Initialise the global class library object.
      minScriptGlobalClassLib = minScript_NewCodeObject()
    If minScriptGlobalClassLib
      ;Add compiler runtime functions.
      ;NONE AT PRESENT.
      ;Add some user defined reference/object types.
        result + minScript_InitArrayTypes()
        result + minScript_InitHashmapTypes()
        result + minScript_InitPointerTypes()
        result + minScript_InitStringBuilderTypes()
        result + minScript_InitClassTypes()
      ;Add the standard run-time.
        result + minScript_InitStandardRuntime()
      ;Add some standard global constants for use by all scripts.
        result + minScript_InitStandardGlobalConstants()
      If result <> #minScript_OKAY
        minScriptGlobalClassLib\Destroy()
        Goto minScriptInit_L2
      EndIf
    Else
minScriptInit_L2:
      minScript_Globals\constantExpressionObject\Destroy()
      Goto minScriptInit_L1
    EndIf
  Else
minScriptInit_L1:
    CompilerIf #PB_Compiler_Thread
      FreeMutex(minScript_Globals\threadMutex)
    CompilerEndIf
    result = 1    
  EndIf    
  ProcedureReturn result
EndProcedure

minScriptINIT = minScriptInit()
;/////////////////////////////////////////////////////////////////////////////////




; IDE Options = PureBasic 5.62 (Windows - x64)
; ExecutableFormat = Shared dll
; CursorPosition = 334
; FirstLine = 321
; Folding = --
; Markers = 24
; EnableThread
; Executable = d.exe.dll.exe.dll
; EnableUnicode